function all_demo_start
    data_gui3(@demostart);
    
function [data,redraw]= demostart( data, redraw )
    data.info =    {
        'data_gui3_demo1.m'                         'Basic demo 1';
        'data_gui3_demo2.m'                         'Basic demo: show layout possibilties';
        'data_gui3_demo3.m'                         'Basic demo: show gui elements';
        'data_gui3_demo_axes.m'                     'Basic demo: Axes';
        'data_gui3_demo_axes_own_callback.m'        'Axes demo: special java callbacks';
        'data_gui3_demo_axes_special_callback.m'    'Axes demo: show special (non-MATLAB) GUI events';
        'data_gui3_demo_change_position.m'          'How to move a figure';
        'data_gui3_demo_checkbox.m'                 'Basic demo: show a checkbox, result in text log';
        'data_gui3_demo_constrain.m'                'Basic demo: how to write constrain handler';
        'data_gui3_demo_deref.m'                    'Basic demo: dereferenced call';
        'data_gui3_demo_figure.m'                   'How to open a sub figure';
        'data_gui3_demo_huge_axes.m'                'How to handle background images and huge axes';
        'data_gui3_demo_label.m'                    'Label element: static text field with text format support';
        'data_gui3_demo_layout1.m'                  'Sample horizontal layout';
        'data_gui3_demo_layout2.m'                  'Sample vertical layout';
        'data_gui3_demo_layout3.m'                  'Sample horizontal layout with space';
        'data_gui3_demo_layout4.m'                  'Sample horizontal right aligned layout';
        'data_gui3_demo_layout5.m'                  'Scalable horizontal layout';
        'data_gui3_demo_layout6.m'                  'Centered horizontal layout';
        'data_gui3_demo_layout7.m'                  'Layout hierarchy';
        'data_gui3_demo_layout8.m'                  'Layout hierarchy 2';
        'data_gui3_demo_layout9.m'                  'Layout hierarchy 3';
        'data_gui3_demo_layout_s1.m'                'Panel layout 1';
        'data_gui3_demo_layout_s2.m'                'Panel layout 2';
        'data_gui3_demo_layout_s3.m'                'Stacked Panel layout';
        'data_gui3_demo_listbox.m'                  'Basic list boxes';
        'data_gui3_demo_panel.m'                    'More complex panel example';
        'data_gui3_demo_popup_2.m'                  'Basic popup boxes';
        'data_gui3_demo_popup_3.m'                  'More popup box example';
        'data_gui3_demo_resize.m'                   'Dynamic layout example';
        'data_gui3_demo_slider.m'                   'Continuouse slider example (non MATLAB function)';
        'data_gui3_demo_table.m'                    'Basic table example';
        'data_gui3_demo_tab.m'                      'Basic tabulator example';
        'data_gui3_demo_timer.m'                    'Basic timer example';
        'data_gui3_demo_tree.m'                     'Basic tree example';
        'data_gui3_demo_treeDyn.m'                  'Basic dynamic tree example';
        'data_gui3_demo_two_axes.m'                 '2 stacked axes';
    };

    info = cell(size(data.info,1),1);
    for i=1:size(data.info,1)
        n = data.info{i,1};
        info{i,1} = [ n(1:length(n)-2) '        ' data.info{i,2}];
    end
    
    i = {
        { 'data.lbstate'      1  [] @stateChanged }
        { 'data.lbtext'       info  }
        { 'data.infotext'    'Select entry' }
        { 'data.buttontext1' 'Run example'    [] @gogogo }
        { 'data.buttontext2' 'Edit'           [] @openedit }
    };
    data = data.CALL.addData(data, i);
 
    gui =  {
        { 'figure'     'demostart'                                   'Name' 'DataGUI3 demo launcher' 'Toolbar' 'none'}
        { 'listbox'    'lb1'           'demostart'  'data.lbstate'   'data.lbtext'  }
        { 'statictext'  'staticinfo'   'demostart'  'data.infotext'                 }
        { 'pushbutton'  'go'           'demostart'  'data.buttontext1'              }
        { 'pushbutton'  'edit'         'demostart'  'data.buttontext2'              }
        } ;
    data = data.CALL.addGui(data, gui);
    
    layout = {{ 0 10 150 10 150 } {'staticinfo' [] 'go' [] 'edit' }};
    layout = {{ 10 30 10 0 10 };{[] layout [] 'lb1' [] }};
    layout = {{ 10 0 10 } {[] layout []}};
    
    data = data.CALL.addLayout( data, 'demostart', layout ); 
    
function [data redraw] = stateChanged( data, redraw, event ) 
    data.infotext = data.info{data.lbstate,2};

function [data redraw] = gogogo( data, redraw, event ) 
    v = data.info{data.lbstate,1};
    v = v(1:length(v)-2);
    try
        feval(v);
    catch exp
        display(exp.message);
    end
    
function [data redraw] = openedit( data, redraw, event ) 
    v = data.info{data.lbstate,1};
    try
    eval([ 'edit ' v ';']);
    catch exp
        display(exp.message);
    end
