function data_gui3_demo1
    data_gui3(@demoinit); % init data stucture

function [data,redraw]= demoinit( data, redraw ) % init callback
    % maintained variable definition:
    i = cell( {
        % variable name; default value; validation; callback 
        { 'data.value'  2   [ 1 10 ]   @updatePlot }
        { 'data.figurename' 'Data gui3 lib demo 1' }
        { 'data.wrongvalue' 'out-of-range' [] @setOutOfRangeValueCB }
        { 'data.bgc'     [ 1 0 1]  }
        { 'data.statustext' ' ' }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    data = data.CALL.addDataErrorCB(data, @dataErrorCB);
    
    % gui element definition:
    g = cell( {
        % obligation definitions                                        optional definitions:
        %                'tagname'      'parent'                        'property name1' 'property value1' 'name 2' 'value 2'
        { 'figure'       'demo1fig'                                     'Name' 'data.figurename' 'color' 'data.bgc'}
        { 'axes'         'axes1'        'demo1fig'                      'color' 'data.bgc'}
        { 'edittext'     'editfield'    'demo1fig' 'data.value'         'backgroundcolor' 'data.bgc'}
        { 'slider'       'slider1'      'demo1fig' 'data.value'         'backgroundcolor' 'data.bgc'}
        { 'pushbutton'   'wrongpush'    'demo1fig' 'data.wrongvalue'    'backgroundcolor' 'data.bgc'}
        { 'statictext'   'statusfield'  'demo1fig' 'data.statustext' }
        } );
    data = data.CALL.addGui(data, g); % create gui elements
    
    % start with layout definiton:
    % create a row with edit field and slider, size: 60 px and 200 px, 10 px space:
    row = {{ 0 120 10 60 10 200 0} {[] 'wrongpush' [] 'editfield' [] 'slider1' [] } };
    % take row and create a column with axes: size: 20px and axes rest of available height
    layout = {{ 26 10 20 10 0 10 };{ 'statusfield' [] row [] 'axes1' [] } };
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout
    
    data = updatePlot( data, struct('empty',[]) ); % initial plot

function [data,redraw] = dataErrorCB(data, redraw, event)
    data.statustext = ['fehler: ' event.error];

function [data,redraw] = setOutOfRangeValueCB( data, redraw, event ) %#ok<INUSD>
    data.value = -1;
    data.statustext = 'data.value is now out-of-range';

function [data,redraw] = updatePlot( data, redraw, event ) %#ok<INUSD>
% plot callback function
    x = -pi:.1:pi;
    % in data.value is the changed value
    y = sin(x) * data.value;
    plot(data.handles.axes1,x,y);
    ylim(data.handles.axes1,[-10 10]);
    xlim(data.handles.axes1,[-pi,pi]);
    data.statustext = 'plot updated';
