function data_gui3_demo3
    data_gui3(@demoinit3); % init data stucture
end

function [data, redraw]= demoinit3(data, redraw) % init callback
    % maintained variable definition:
    i = cell( {
        % variable name; default value; validation; callback 
        { 'data.value123'       2                           [ 1 3 ]         @updatePlot     }
        { 'data.figureName'     'Data gui 3 - demo 3'                                       }
        { 'data.newfig'         'New figure'                []              @openfigure     }
        { 'data.menu13'         'Menu1.3 with callback'     []              @menucallback   }
        { 'data.radio3text'     'R3'                                                        }
        { 'data.set_error'      'Set wrong value (4)'       []              @set_error      }
        { 'data.tabswap'        1                           [ 0 1 ]         @swap_panel     }
        { 'data.tabvisible2'    'off'                                                       }
        { 'data.tabvisible3'    'on'                                                        }
        { 'data.tablein'        (1:.1:2)'                   @table_check    @updatePlot     }  % defined as numeric array
        { 'data.toggletext'     'toggle panel 2/3'                                          }
        { 'data.starttimer'     'Start timer'               []              @startTimer     }
        { 'data.timervalue'     0                           [0 1]           @timerCallback  }
        { 'data.timerout'       'changed by timer'                                          }
        { 'data.bgc'            [ 0.8 0.8 0.8 ]                                             }
        { 'data.fgc'            [ .1 .1 .1 ]                                                }
        { 'data.axescolor'      'none'                                                      }
        { 'data.empty'          []                                                          }
        { 'data.colchange'      'Color'                     []              @colorCycle     }
        { 'data.bgvisible'      'off'                                                       }
        { 'data.panelbg'        [.3 .3 .3]                                                  }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    data.fenster = 1;
    
    % gui element definition:
    g = cell( {
        % obligation definitions                            |-> optional definitions:
        %                                                   |-> 'property name1' 'property value1' 'name 2' 'value 2'
        { 'figure'      'demo3fig'                                 'Name' 'data.figureName' 'Toolbar' 'none' 'Menubar' 'none' 'color' 'data.bgc'}
        { 'menuitem'    'menu1'     'demo3fig'   'Menu1'           }
        { 'menuitem'    'menu1_1'   'menu1'      'Menu1.1'         }
        { 'menuitem'    'menu1_2'   'menu1'      'Menu1.2'         }
        { 'menuitem'    'menu1_2_1' 'menu1_2'    'Menu1.2.1'       }
        { 'menuitem'    'menu1_3'   'menu1'      'data.menu13'     }
        { 'menuitem'    'menu2'     'demo3fig'   'Menu2'           }
        { 'menuitem'    'menu2_1'   'menu2'      'Menu2.1'         'Accelerator' 'K' }
        { 'pushbutton'  'push1'     'demo3fig'   'data.newfig'     'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'statictext'  'static1'   'demo3fig'   'Value of data.value123:' 'backgroundcolor' 'data.bgc'  'foregroundcolor' 'data.fgc'}
        { 'statictext'  'static2'   'demo3fig'   'data.value123'   'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'pushbutton'  'push2'     'demo3fig'   'data.set_error'  'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'edittext'    'edit1'     'demo3fig'   'data.value123'   'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'slider'      'slider1'   'demo3fig'   'data.value123'   'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'radiogroup'  'radiogroup1' 'demo3fig'   'data.value123' ...
                 { 'data.radio3text' 'R2' 'R1'}                    'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'popupbox'    'popup1'    'demo3fig'   'data.value123' ...
                'Pop 1|Pop 2|Pop 3'                                'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'listbox'     'list1'     'demo3fig'   'data.value123' ...
                'List 1|List 2|List 3'                             'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'panel'       'panel1'    'demo3fig'                     'title' 'data.toggletext'    'backgroundcolor' 'data.panelbg'  'foregroundcolor' 'data.fgc'}
        { 'panel'       'panel2'    'demo3fig'                     'title' 'Panel 2' 'visible' 'data.tabvisible2' 'backgroundcolor' 'data.panelbg'  'foregroundcolor' 'data.fgc'}
        { 'panel'       'panel3'    'demo3fig'                     'title' 'Panel 3' 'visible' 'data.tabvisible3' 'backgroundcolor' 'data.panelbg'  'foregroundcolor' 'data.fgc'}
        { 'checkbox'    'checkbox1' 'demo3fig'   'data.tabswap'    'string' 'data.toggletext'   'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        {'togglebutton' 'toggle1'   'demo3fig'   'data.tabswap'  ...
                'data.toggletext'                                  'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'statictext'  'static3'   'demo3fig'   'inside panel 2'  'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'statictext'  'static4'   'demo3fig'   'inside panel 3'  'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'axes'        'axes1'     'demo3fig'                     'color' 'data.axescolor' 'xcolor' 'data.fgc' 'ycolor' 'data.fgc'}
        { 'axes'        'axes2'     'demo3fig'                     'color' 'data.axescolor' 'xcolor' 'data.fgc' 'ycolor' 'data.fgc'}
        { 'table'       'table1'    'demo3fig'   'data.tablein'    'ColumnEditable' true 'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'edittext'    'edit2'     'demo3fig'   'data.figureName' 'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'pushbutton'  'push_starttimer'   'demo3fig'   'data.starttimer' 'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'statictext'  'static_timer_target'   'demo3fig'   'data.timerout'  'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}
        { 'timer'       'timer1'    'data.timervalue'                       'ExecutionMode' 'fixedSpacing' 'Period' 3  }
        { 'axes'        'axesbg'    'demo3fig'                      'Xticklabel' 'data.empty' ...
            'YTicklabel' 'data.empty' 'XTick' 'data.empty' 'YTick' 'data.empty'  'visible' 'data.bgvisible'}
        { 'panel'       'panelbg'   'demo3fig'                          }     
        { 'pushbutton'  'pushcol'   'demo3fig'   'data.colchange'     'backgroundcolor' 'data.bgc' 'foregroundcolor' 'data.fgc'}

        } );
    data = data.CALL.addGui(data, g); % create gui elements
    
    panel3in   = {{ 0 20 2 20 0 };{[] 'edit2' [] 'static4' }};
    panel_tab  = {{ 'panel2' 'panel3' } { 'static3' panel3in }};
    hide_col   = {{ 0 20 2 20 0};{[] 'checkbox1' [] 'toggle1' [] }};
    panel_1    = {{ 'panel1'} { hide_col }};
    panel_row  = {{ 0 200 2 200 0 } {[] panel_tab [] panel_1 [] }};
    
    axes_row  = {{10 140 0 0 10 } {[] 'table1' 'axes1' 'axes2' [] }};
    
    radios   = {{ 0 15 2 15 2 15 0};{[] 'radiogroup1_1' [] 'radiogroup1_2' [] 'radiogroup1_3' [] }};
    radiog   = { { 'radiogroup1' } { radios } };
    static_row_123 = {{ 0 200 2 80 2 80 0 } { [] 'static1' [] 'static2' [] 'edit1' []} } ;
    slider_row_123 = {{0 2 150  2 80 } { 'slider1' [] 'push2' [] 'popup1' } };
    static_slider  = { {0 20 2 20 0} ; {[] slider_row_123 [] static_row_123 []} };
    row123         = { { 0 80 80 } { static_slider 'list1' radiog } };
        
    layout   = {{100 100 0 100} {'push1' 'push_starttimer' 'static_timer_target' 'pushcol'} };
    layout   = data.CALL.layoutVCenter(10, {20 100 80 0 }, {  layout panel_row row123 axes_row} );
    layout   = {{20 20 100 20 80 20 0 } ;{  layout [] panel_row [] row123 [] axes_row} };
    layout = {{ 'axesbg' 'panelbg' } { [] layout }};
    data     = data.CALL.addLayout(data, 'demo3fig', layout);
    
    %data.pownie = imread('/home/meykopff/download/My_Little_Pony_Lineart_10_by_MoogleyMog.jpg');
    %data.pownie = imread('/home/meykopff/download/my_little_pony_by_caperuza-d32suoo.jpg');
    [data, redraw] = updatePlot(data, redraw, []);
end

function [data, redraw] = updatePlot(data, redraw, event) %#ok<INUSD>
% simple plot function
    Y = data.tablein * data.value123;
    set( 0, 'currentfigure', data.handles.demo3fig ); % because we can handle more than one figure we must fix the current figure in the root object
    set( data.handles.demo3fig, 'currentaxes', data.handles.axes1 ); % set current axes, next plot doesen't use axes handle
    plot( 0:1:10, Y,'LineWidth',2 );
    Y = sin(data.tablein) * data.value123 ;
    plot( data.handles.axes2, 0:1:10, Y, 'LineWidth',2 ); % this plot use axes handle, so we don't active the axes object
end

function [data, redraw] = set_error(data, redraw, event) %#ok<INUSD>
% simple callback function, demonstrate some data functions
    
    new123Value = 4; % 4 is out of range !
    data.value123 = new123Value; % force error, set dependend objects red
end

function [data, value, error] = table_check( data, value, error)
% this is a table data check function
% data.tablein is defined as an array, the uitable object handles cell
% arrays also and if you used them your check function has to be modified.
    for i=1:length(value)
        if isnan(value(i))
            error = ['entry ' num2str(i) ' is not a number'];
            return;
        end
    end
end

function [data, redraw] = swap_panel(data, redraw, event) %#ok<INUSD>
% toggle panel visiblity
    if data.tabswap == 1
        data.tabvisible2 = 'off';
        data.tabvisible3 = 'on';
    else
        data.tabvisible2 = 'on';
        data.tabvisible3 = 'off';
    end
end

function [data, redraw] = openfigure(data, redraw, event) %#ok<INUSD>
% open a new figure with gui elements
    data.fenster = data.fenster + 1;
    
    figuretag = [ 'demo3fig_' num2str(data.fenster) ]; % we need unique tags
    buttontag = [ 'push1_' num2str(data.fenster) ];
    slidertag = [ 'slider1_' num2str(data.fenster) ];
    figuretitle = [ data.figureName ' - ' num2str(data.fenster) ];
    
    g = cell( {
        { 'figure'     figuretag                            	'Name' figuretitle }
        } );
    data = data.CALL.addGui(data, g); % create gui elements
    
    g = cell( {
     %   { 'figure'     figuretag                            	'Name' figuretitle }
        { 'pushbutton' buttontag    figuretag 'data.newfig'     }
     %   { 'slider'     slidertag    figuretag 'data.value123'   }
        } );
    data = data.CALL.addGui(data, g); % create gui elements
    g = cell( {
     %   { 'figure'     figuretag                            	'Name' figuretitle }
     %   { 'pushbutton' buttontag    figuretag 'data.newfig'     }
        { 'slider'     slidertag    figuretag 'data.value123'   }
        } );
    data = data.CALL.addGui(data, g); % create gui elements
    
    slider = data.CALL.layoutHCenter(0, {200}, { slidertag } );
    layout = data.CALL.layoutHCenter(0, {100}, { buttontag } );
    layout = data.CALL.layoutVCenter(5, {20 100}, { slider layout } );
    data = data.CALL.addLayout(data, figuretag, layout);
    
    %lets move the new figure:
    myfig = data.CALL.resolveTag(data, figuretag );
    pos = get(myfig, 'position');
    pos(1) = pos(1) + (data.fenster * 30);
    pos(2) = pos(2) - (data.fenster * 30);
    set( myfig, 'position', pos);
end

function [data, redraw]= startTimer( data, redraw, event )  %#ok<INUSD>
    switch data.timervalue
        case 0
            data.timervalue = 1;
        case 1
            data.timervalue = 0;
        otherwise
            data.timervalue = 0;
    end
end

function [data, redraw] = timerCallback( data, redraw, event ) %#ok<INUSD>
    data.timerout = ['changed by timer ' datestr(now)];
end

function [data, redraw] = colorCycle( data, redraw, event ) %#ok<INUSD>
    delete(get(data.handles.axesbg,'children')) % remove old bg image
    if ~isfield(data,'colcycle'); data.colcycle = 0; end
    themes = {  [1 1 1]         [0 0 0]         []  ;
                [0 0 0]         [1 1 1]         []  ;
                [0.8 0.8 0.8]   [.1 .1 .1]      []  ;
                [0.8 0.8 0.8]   [.1 .1 .1]      []  ;                 
              };
    data.colcycle = mod(data.colcycle, size(themes,1))+1;
    [data.bgc, data.fgc, bg] = themes{data.colcycle,:};
    if ~isempty(bg)
        image(bg, 'parent', data.handles.axesbg);
    end
end
