function data_gui3_demo_axes_own_callback
    data_gui3(@demoinit); % init data stucture

function [data redraw] = demoinit( data, redraw ) % init callback
    i = cell( {
        { 'data.figname'  'Data gui3 lib demo double axes'  }
        { 'data.postxtX'   'resultX' }
        { 'data.postxtY'   'resultY' }
        { 'data.closetext' 'Close'  [] @close }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    g = cell( {
        { 'figure'        'demo1fig'                                         'Name' 'data.figname'  ...
            'FocusGainedCallback'  @JavaCallback ...
            'FocusLostCallback'    @JavaCallback  ...
            'KeyPressedCallback'   @JavaCallback  ...
            'KeyReleasedCallback'  @JavaCallback  ...
            'KeyTypedCallback'     @JavaCallback  ...
            'MouseClickedCallback' @JavaCallback  ...
            'MouseDraggedCallback' @JavaCallback  ...
            'MouseEnteredCallback' @JavaCallback  ...
            'MouseExitedCallback'  @JavaCallback  ...
            'MouseMovedCallback'   @JavaCallback  ...
            'MousePressedCallback'    @JavaCallback  ...
            'MouseReleasedCallback'   @JavaCallback  ...
            'MouseWheelMovedCallback' @JavaCallback  ...
            'PropertyChangeCallback'  @JavaCallback  ...
            }
        { 'axes'          'axes1'        'demo1fig'                           }
        { 'statictext'    'posX'         'demo1fig'  'data.postxtX'           }
        { 'statictext'    'posY'         'demo1fig'  'data.postxtY'           }
        { 'pushbutton'    'close'        'demo1fig'  'data.closetext'         }
        } );    
    data = data.CALL.addGui(data, g); % create gui elements
    
    layout = {{ 0 10 0 50} { 'posX' [] 'posY' 'close'}};
    layout = {{ 30 0 } ; { layout 'axes1' }};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout
        
    x1 = 0:.1:40;
    y1 = 4.*cos(x1)./(x1+2);
    l = line(x1,y1,'Color','b','parent',data.handles.axes1,'LineWidth',8);    
    set(l, 'ButtonDownFcn', data.CALL.wrapCallback(@lineCBnew) );
    
function [data redraw] = JavaCallback(data, redraw, event)
    display(event);
    if isfield(event,'jEvent')
        display(event.jEvent)
    end

function [data redraw] = lineCBnew(data, redraw, event)
    display(event);
    
function [data redraw] = close(data, redraw, event)
    delete(data.handles.demo1fig); % close main figure
    redraw = false; % disable redraw !
    