function data_gui3_demo_figure_close
    data_gui3(@demoinit, mfilename); % init data stucture

function [data,redraw]= demoinit( data, redraw, filename ) % init callback
    i = cell( {
        { 'data.f2on'  'Figure 2 On'  [] @f2on}
        { 'data.f2off' 'Figure 2 Off' [] @f2off}
        { 'data.p1'    'Show Panel 1' [] @p1}
        { 'data.p2'    'Show Panel 2' [] @p2 }
        { 'data.visiblef2' 'on' };
        { 'data.visiblep1' 'on' };
        { 'data.visiblep2' 'off' };
    });
    data = data.CALL.addData(data, i); % add to data strukture

    g = cell( {
        { 'figure'       'demo1fig'                          'Name' 'Main Figure' 'position' [ 500 400 500 150] 'MenuBar' 'none' 'CloseRequestFcn' @fig1close }
        { 'pushbutton'   'f2onpush'     'demo1fig' 'data.f2on'    }
        { 'pushbutton'   'f2offpush'    'demo1fig' 'data.f2off'    }
        { 'pushbutton'   'p1push'       'demo1fig' 'data.p1'    }
        { 'pushbutton'   'p2push'       'demo1fig' 'data.p2'    }        
        { 'figure'       'demo2fig'                          'Name' 'Wizard Figure' 'position' [ 500 200 500 150] 'MenuBar' 'none' 'visible' 'data.visiblef2' 'CloseRequestFcn' @fig2close}
        { 'panel'        'panel1'   'demo2fig'               'title' 'Panel1' 'visible' 'data.visiblep1' }
        { 'panel'        'panel2'   'demo2fig'               'title' 'Panel2' 'visible' 'data.visiblep2' }
        } );
    data = data.CALL.addGui(data, g); % create gui elements

    layout  = {{ 0 0 0 0 } { 'f2onpush' 'f2offpush' 'p1push' 'p2push' }};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout
    
    layout = {{ 'panel1' 'panel2'} { [] [] }};    
    data = data.CALL.addLayout( data, 'demo2fig', layout ); % use layout

function [data redraw] = f2on(data, redraw, event)
    data.visiblef2 = 'on';
    
function [data redraw] = f2off(data, redraw, event)
    data.visiblef2 = 'off';
    
function [data redraw] = p1(data, redraw, event)
    data.visiblep1 = 'on';
    data.visiblep2 = 'off';

function [data redraw] = p2(data, redraw, event)
    data.visiblep1 = 'off';
    data.visiblep2 = 'on';

function [data redraw doclose] = fig1close(data, redraw, doclose)
    if ~strcmp(questdlg('Quit'),'Yes'); doclose=false; end
    
function [data redraw doclose] = fig2close(data, redraw, doclose)
    display('hide figure 2');
    doclose = false;
    data.visiblef2 = 'off';
