function data_gui3_demo_slider
    data_gui3(@demoinit); % init data stucture
end

function [data redraw]= demoinit( data, redraw ) % init callback
    i = cell( {
        { 'data.value'      2                   [ 1 10 ]    @updatePlot }
        { 'data.contstate'  1                   [ 0 1 ]                 }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    g = cell( {
        { 'figure'       'demo1fig'                                     'Name' 'Data gui3 lib demo slider'  }
        { 'axes'         'axes1'        'demo1fig'                      }
        { 'slider'       'slider1'      'demo1fig' 'data.value'         'Continuouse' 'data.contstate'      }
        { 'checkbox'     'checkbox1'    'demo1fig' 'data.contstate'     'string' 'Continuouse on/off'       }
        } );
    data = data.CALL.addGui(data, g); % create gui elements

    layout = {{ 0 300 0 } {[] 'checkbox1' [] }};
    layout = {{ 30 30 0 } ; {layout 'slider1' 'axes1' }};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout  
    
    % find created axes by tag and store handle. we need this handle for plotting
    data.axes1 = data.CALL.resolveTag( data, 'axes1' ); 
    data = updatePlot( data, struct() ); % initial plot
end

function [data redraw] = updatePlot( data, redraw, event ) %#ok<INUSD>
% plot callback function
    x = -pi:.1:pi;
    y = sin(x) * data.value;
    plot(data.axes1,x,y);
    ylim(data.axes1,[-10 10]);
    xlim(data.axes1,[-pi,pi]);
end
