function data_gui3_demo_tab
    data_gui3(@demoinit); % init data stucture
end

function [data redraw] = demoinit( data, redraw ) % init callback
    % maintained variable definition:
    i = cell( {
        % variable name; default value; validation; callback 
        { 'data.value'  1   [ 1 4 ]   @tab_changed}
        { 'data.col'    [1 0 0] }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    % gui element definition:
    g = cell( {
        % obligation definitions                                            optional definitions:
        %                'tagname'  'parent'                                'property name1' 'property value1' 'name 2' 'value 2'
        { 'figure'       'demo1fig'                                         'Name' 'Data gui3 lib demo tabulator'}
        { 'slider'       'slider1'   'demo1fig' 'data.value'                 }
        { 'tabgroup'     'tabgroup1' 'demo1fig' 'data.value' ...
                 { 't1name' 't2name' 't3name' 't4name' } 'backgroundcolor' 'data.col'                    }
        { 'statictext' 'statict1' 'demo1fig' 'Inside tab 1'   }
        { 'statictext' 'statict2' 'demo1fig' 'Inside tab 2'   }
        { 'statictext' 'statict3' 'demo1fig' 'Inside tab 3'   }
        { 'statictext' 'statict4' 'demo1fig' 'Inside tab 4'   }
                 
        } );    
    data = data.CALL.addGui(data, g); % create gui elements
    
    page1 = {{ 0 } { 'statict1' }};
    page2 = {{ 0 } { 'statict2' }};
    page3 = {{ 0 } { 'statict3' }};
    page4 = {{ 0 } { 'statict4' }};
    
    tg   = { { 'tabgroup1' '' '' '' } { page1 page2 page3 page4 } };
    layout = {{ 30 0 };{'slider1' tg }};
    
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout    
end

function [data, redraw] = tab_changed( data, redraw, event ) %#ok<INUSD>
    switch round(data.value)
        case 1
            data = data.CALL.defaultValue(data, 'data.col');
        case 2
            data.col = [1 1 0];
        case 3
            data.col = [0 1 1];
        case 4
            data.col = [0 1 0];
        otherwise
    end
end

