function data_gui3_demo_tree
    data_gui3(@demoinit); % init data stucture
end

function [data redraw] = demoinit( data, redraw ) % init callback

    nodelist = { 
        0 'node0'   fullfile(matlabroot,'/toolbox/matlab/icons/warning.gif') 'mydata'; 
        1 'node1.1' [] 1; 
        1 'node1.2' [] 2; 
        2 'node2,1' [] 'test'; 
        1 'node1,3' [] { 'cell' }; 
        2 'node2,1' [] []; 
        2 'node2,2' [] 3; 
        };

    i = cell( {
        { 'data.nodes'          nodelist    []                  }
        { 'data.nodesSelected'  0           []  @nodeSelectedCB }
        { 'data.treeDrop'       true        []  @treeDropCB     }
        { 'data.treemod1'       'Do something with tree 1' [] @treemod1 }
        { 'data.treemod2'       'Do something with tree 2' [] @treemod2 }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    g = cell( {
        %  type         tagname       parent      parameter                           optional parameters
        { 'figure'      'demo1fig'                                                    'Name' 'Data gui deref demo' }
        { 'tree'        'mytree'      'demo1fig'  'data.nodes' 'data.nodesSelected'   'MultipleSelectionEnabled' false 'DragDropEnabled' 'data.treeDrop'}
        { 'pushbutton'  'treemod1'    'demo1fig'  'data.treemod1'                      }
        { 'pushbutton'  'treemod2'    'demo1fig'  'data.treemod2'                      }
        } );
    data = data.CALL.addGui(data, g); % create gui elements
  
    layout = {{ 30 30 0 };{'treemod2' 'treemod1' 'mytree' }};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout    
end

function [data redraw] = nodeSelectedCB(data, redraw, event) %#ok<INUSD>
    display('nodeSelectedCB');
    display(num2str(data.nodesSelected));
    %event
    if length(data.nodesSelected) == 1
        %data.nodes{data.nodesSelected,:}
    end
end

function [data redraw]= treeDropCB (data, redraw, event)
    display('treeDropCB');
    event
end

function [data redraw]= treemod1 (data, redraw, event)
    data.nodes = { 
        0 ['node0 ' num2str(rand)]  [] 'mydata'; 
        1 ['node1.1' num2str(rand)] [] 1; 
        1 ['node1.2' num2str(rand)] [] 2; 
        2 ['node2,1' num2str(rand)] [] 'test'; 
        1 ['node1,3' num2str(rand)] [] { 'cell' }; 
        2 ['node2,1' num2str(rand)] fullfile(matlabroot,'/toolbox/matlab/icons/warning.gif') []; 
        2 ['node2,2' num2str(rand)] [] 3; 
        };

end

function [data redraw]= treemod2 (data, redraw, event)
    data.nodes = { 
        0 ['node ' num2str(rand)]  [] 'mydata'; 
        1 ['node ' num2str(rand)] [] 1; 
        2 ['node ' num2str(rand)] [] 2; 
        1 ['node ' num2str(rand)] [] 'test'; 
        2 ['node ' num2str(rand)] [] { 'cell' }; 
        3 ['node ' num2str(rand)] [] []; 
        4 ['node ' num2str(rand)] [] 3; 
        1 ['node ' num2str(rand)] [] 1; 
        2 ['node ' num2str(rand)] [] 2; 
        1 ['node ' num2str(rand)] [] 'test'; 
        };
end
