function data_gui3_demo_treeDyn()
    beam_dyn_path = fullfile( fileparts(mfilename('fullpath')), '..','add_beam_dynamics_path.m');
    if exist(beam_dyn_path,'file'); run( beam_dyn_path ); end %include beam_dynamics folder in matlab path
    if isempty(which('data_gui3')); errordlg('add data_gui3 to your matlab path','data_gui2.m not found'); return; end
    data_gui3(@go); % init data stucture
end

function [data redraw] = go( data, redraw ) % init callback
    % maintained variable definition:
    i = cell( {
        % variable name; default value; validation; callback 
        { 'data.treeData'      {'/' true 'DOOCS' [] }   []    @treeExpandCB   }
        { 'data.treeSelected'  {}   []  @treeSelectedCB }
        { 'data.treeDrop'      true []    @treeDropCB     }
        { 'data.figpos'        [ 200 200 500 500] }
        { 'data.wrongvalue' 'Useless pushbutton' [] @uselessButton}        
        { 'data.wrongvalue2' 'Useless pushbutton2' [] @uselessButton2}
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    % gui element definition:
    g = cell( {
        % obligation definitions                            |-> optional definitions:
        %                                                   |-> 'property name1' 'property value1' 'name 2' 'value 2'
        { 'figure' 'treedynfig'                             'Name' 'DATA GUI dynamic tree demo' ...
        'Toolbar' 'none' 'Menubar' 'none' 'NumberTitle' 'off'  'position' 'data.figpos' }
        { 'treedyn' 'mytree' 'treedynfig' 'data.treeData' 'data.treeSelected'  'MultipleSelectionEnabled' true 'DragDropEnabled' 'data.treeDrop' }
        { 'pushbutton'   'wrongpush'    'treedynfig' 'data.wrongvalue' }        
        { 'pushbutton'   'wrongpush2'   'treedynfig' 'data.wrongvalue2' }        
        } );
    data = data.CALL.addGui(data, g); % create gui elements
   
    layout = { { 10 0 10 } { [] 'mytree' []}};
    layout = { { 30 30 10 0 10 };{ 'wrongpush2' 'wrongpush' [] layout  [] }};
    data     = data.CALL.addLayout(data, 'treedynfig', layout);
    
    data = data.CALL.expandTree(data, 'mytree', '/');
end

function [data redraw] = treeSelectedCB(data, redraw, event) %#ok<INUSD>
    %display(['data_gui3_demo_treeDyn::' 'treeSelectedCB'])
    %data.treeSelected % user data of current selected tree nodes
    %event
end

function [data nodes] = treeExpandCB(data, nodes, event) %#ok<INUSL>
    display(['data_gui3_demo_treeDyn::' 'treeExpandCB'])
    parent = event.parentNode;
    level = length(strfind(parent,'/'));
    nodes = {  [parent 'UTIL/']        true    ['UTIL' num2str(level+1)]      []};
end

function [data redraw] = treeDropCB(data, redraw, event) %#ok<INUSD>
    %display(['data_gui3_demo_treeDyn::' 'treeDropCB'])
    %event
end

function [data redraw] = uselessButton(data, redraw, event) %#ok<INUSD>
    data.treeData = {  'rootNew0/' false 'DOOCS_1234556787890'   [] };
end

function [data redraw] = uselessButton2(data, redraw, event) %#ok<INUSD>
    data.treeData = {  'rootNew/' true 'DOOCS!'   [] };
end
